"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformLuaLibFunction = exports.importLuaLibFeature = exports.getUsedLuaLibFeatures = exports.LuaLibFeature = void 0;
const lua = require("../../LuaAST");
const LuaLib_1 = require("../../LuaLib");
Object.defineProperty(exports, "LuaLibFeature", { enumerable: true, get: function () { return LuaLib_1.LuaLibFeature; } });
const utils_1 = require("../../utils");
const luaLibFeatures = new WeakMap();
function getUsedLuaLibFeatures(context) {
    return utils_1.getOrUpdate(luaLibFeatures, context, () => new Set());
}
exports.getUsedLuaLibFeatures = getUsedLuaLibFeatures;
function importLuaLibFeature(context, feature) {
    getUsedLuaLibFeatures(context).add(feature);
}
exports.importLuaLibFeature = importLuaLibFeature;
function transformLuaLibFunction(context, feature, tsParent, ...params) {
    importLuaLibFeature(context, feature);
    const functionIdentifier = lua.createIdentifier(`__TS__${feature}`);
    return lua.createCallExpression(functionIdentifier, params, tsParent);
}
exports.transformLuaLibFunction = transformLuaLibFunction;
//# sourceMappingURL=lualib.js.map