"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformDoStatement = exports.transformWhileStatement = void 0;
const lua = require("../../../LuaAST");
const utils_1 = require("./utils");
exports.transformWhileStatement = (statement, context) => lua.createWhileStatement(lua.createBlock(utils_1.transformLoopBody(context, statement)), context.transformExpression(statement.expression), statement);
exports.transformDoStatement = (statement, context) => {
    const body = lua.createDoStatement(utils_1.transformLoopBody(context, statement));
    let condition = context.transformExpression(statement.expression);
    if (lua.isUnaryExpression(condition) && condition.operator === lua.SyntaxKind.NotOperator) {
        condition = condition.operand;
    }
    else {
        condition = lua.createUnaryExpression(condition, lua.SyntaxKind.NotOperator);
    }
    return lua.createRepeatStatement(lua.createBlock([body]), condition, statement);
};
//# sourceMappingURL=do-while.js.map