"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEmitOutputCollector = void 0;
const utils_1 = require("../utils");
function createEmitOutputCollector() {
    const files = [];
    const writeFile = (fileName, data, _bom, _onError, sourceFiles = []) => {
        let file = files.find(f => utils_1.intersection(f.sourceFiles, sourceFiles).length > 0);
        if (!file) {
            file = { sourceFiles: [...sourceFiles] };
            files.push(file);
        }
        else {
            file.sourceFiles = utils_1.union(file.sourceFiles, sourceFiles);
        }
        if (fileName.endsWith(".lua")) {
            file.lua = data;
        }
        else if (fileName.endsWith(".lua.map")) {
            file.luaSourceMap = data;
        }
        else if (fileName.endsWith(".js")) {
            file.js = data;
        }
        else if (fileName.endsWith(".js.map")) {
            file.jsSourceMap = data;
        }
        else if (fileName.endsWith(".d.ts")) {
            file.declaration = data;
        }
        else if (fileName.endsWith(".d.ts.map")) {
            file.declarationMap = data;
        }
    };
    return { writeFile, files };
}
exports.createEmitOutputCollector = createEmitOutputCollector;
//# sourceMappingURL=output-collector.js.map